#include <stdio.h>
#include <stdlib.h>
#include "list.h"


struct IdList* initIdList()
{
  struct IdList* new = (struct IdList*) malloc(sizeof(struct IdList));
  new->head = 0;
  return new;
}

struct ListNode *addFrontId(struct IdList *list, void *data, void *Id){
  struct ListNode *node = (struct ListNode*) malloc(sizeof(struct ListNode));
  if (node == NULL){
    perror("malloc returned a NULL");
    exit(1);
  }
  node->data = data;
  node->Id = Id;
  node->next = list->head;
  list->head = node;
  return node;
};

struct ListNode *appendId(struct IdList *list, void *data, void *Id){
  struct ListNode* new;
  if (list->head == NULL){
    list->head = (struct ListNode*) malloc(sizeof(struct ListNode));
    new = list->head;
  }
  else{
    struct ListNode* node = list->head;
    while (node->next != NULL)
      node = node->next;
    node->next = (struct ListNode*) malloc(sizeof(struct ListNode));
    new = node->next;
  }
  new->Id = Id;
  new->next = NULL;
  new->data = data;
  return new;
};

struct ListNode *indexIdList(struct IdList *list, int idx){
  struct ListNode* node = list->head;
  while (idx > 0){
    node = node->next;
    idx--;
  }
  return node;
};

void removeIdList(struct IdList *list, void *Id){
  if (isEmptyList(list))
    return;

  if (list->head->Id == Id){
    struct ListNode *tmp = list->head;
    list->head = list->head->next;
    free(tmp);
    return;
  }

  struct ListNode* fst = list->head;
  struct ListNode* snd = list->head->next;
  while(snd){
    if (snd->Id != Id){
      snd = snd->next;
      continue;
    }
    fst->next = snd->next;
    free(snd);
    return;
  }
};

struct ListNode *findNodeId(struct IdList *list, void *Id){
    struct ListNode* node = list->head;
    while (node != 0){
        if (node->Id == Id)
            return node;
        node = node->next;
    }
    return NULL;
}

int isEmptyList(struct IdList *list)
{
  return (list->head == 0);
}
